DevExtreme v24.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Lookup - Basics

The JavaScript Lookup component allows users to search through its drop-down list and select a single item. The drop-down list can be grouped by category.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo’s accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the Lookup features used.
Backend API
$(() => { $('#lookup').dxLookup({ dropDownOptions: { showTitle: false, }, items: employeesList, value: employeesList[0], inputAttr: { 'aria-label': 'Simple lookup', }, }); $('#lookup-grouped').dxLookup({ dataSource: new DevExpress.data.DataSource({ store: new DevExpress.data.ArrayStore({ data: employeesTasks, key: 'ID' }), group: 'Assigned', }), dropDownOptions: { hideOnOutsideClick: true, showTitle: false, }, grouped: true, displayExpr: 'Subject', inputAttr: { 'aria-label': 'Grouped lookup', }, }); });
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="dx-fieldset"> <div class="dx-fieldset-header">Simple lookup</div> <div class="dx-field"> <div id="lookup"></div> </div> </div> <div class="dx-fieldset"> <div class="dx-fieldset-header">Grouped lookup</div> <div class="dx-field"> <div id="lookup-grouped"></div> </div> </div> </div> </body> </html>
.dx-theme-generic .dx-fieldset, .dx-theme-material .dx-fieldset { width: 40%; float: left; } .dx-field > .dx-lookup { flex: 1; }
const employeesList = ['John Heart', 'Samantha Bright', 'Arthur Miller', 'Robert Reagan', 'Greta Sims', 'Brett Wade', 'Sandra Johnson', 'Ed Holmes', 'Barb Banks', 'Kevin Carter', 'Cindy Stanwick', 'Sammy Hill', 'Davey Jones', 'Victor Norris', 'Mary Stern', 'Robin Cosworth', 'Kelly Rodriguez', 'James Anderson', 'Antony Remmen', 'Olivia Peyton', 'Taylor Riley', 'Amelia Harper', 'Wally Hobbs', 'Brad Jameson', 'Karen Goodson', 'Marcus Orbison', 'Sandy Bright', 'Morgan Kennedy', 'Violet Bailey', 'Ken Samuelson', 'Nat Maguiree', 'Bart Arnaz', 'Leah Simpson', 'Arnie Schwartz', 'Billy Zimmer', 'Samantha Piper', 'Maggie Boxter', 'Terry Bradley', 'Gabe Jones', 'Lucy Ball', 'Jim Packard', 'Hannah Brookly', 'Harv Mudd', 'Clark Morgan', 'Todd Hoffman', 'Jackie Garmin', 'Lincoln Bartlett', 'Brad Farkus', 'Jenny Hobbs', 'Dallas Lou', 'Stu Pizaro']; const employeesTasks = [{ ID: 1, Assigned: 'Mr. John Heart', Subject: 'Choose between PPO and HMO Health Plan', }, { ID: 2, Assigned: 'Mr. John Heart', Subject: 'Google AdWords Strategy', }, { ID: 3, Assigned: 'Mr. John Heart', Subject: 'New Brochures', }, { ID: 4, Assigned: 'Mr. John Heart', Subject: 'Update NDA Agreement', }, { ID: 5, Assigned: 'Mr. John Heart', Subject: 'Review Product Recall Report by Engineering Team', }, { ID: 6, Assigned: 'Mrs. Olivia Peyton', Subject: 'Update Personnel Files', }, { ID: 7, Assigned: 'Mrs. Olivia Peyton', Subject: 'Review Health Insurance Options Under the Affordable Care Act', }, { ID: 8, Assigned: 'Mrs. Olivia Peyton', Subject: 'Non-Compete Agreements', }, { ID: 9, Assigned: 'Mrs. Olivia Peyton', Subject: 'Give Final Approval for Refunds', }, { ID: 10, Assigned: 'Mr. Robert Reagan', Subject: 'Deliver R&D Plans for 2013', }, { ID: 11, Assigned: 'Mr. Robert Reagan', Subject: 'Decide on Mobile Devices to Use in the Field', }, { ID: 12, Assigned: 'Mr. Robert Reagan', Subject: 'Try New Touch-Enabled WinForms Apps', }, { ID: 13, Assigned: 'Mr. Robert Reagan', Subject: 'Approval on Converting to New HDMI Specification', }, { ID: 14, Assigned: 'Ms. Greta Sims', Subject: 'Approve Hiring of John Jeffers', }, { ID: 15, Assigned: 'Ms. Greta Sims', Subject: 'Update Employee Files with New NDA', }, { ID: 16, Assigned: 'Ms. Greta Sims', Subject: 'Provide New Health Insurance Docs', }];

Bind the Component to Data

To bind the component to data, use one of these properties:

  • items[]
    Accepts a local data array (see the Simple JavaScript Lookup code below).

  • dataSource
    Accepts a local data array or a DataSource object. This object works with local and remote arrays and allows you to shape data. In this demo, a DataSource instance is configured to group a local array of objects (see the Grouped JavaScript Lookup code below).

Both properties work with arrays of primitives or objects. If you use objects, specify the following properties:

  • valueExpr
    A data field that contains unique values used to identify items.

  • displayExpr
    A data field whose values should be displayed in the drop-down list.

When a user selects an item, the JavaScript Lookup component saves the corresponding value from the valueExpr data field in the value property. You can also specify the value property in code to preselect an item as shown in the Simple JavaScript Lookup use case.

Group Data

You can group data items in the drop-down list.

If the data source contains ungrouped data items, use the DataSource's group property to specify the data field to group by.

The JavaScript Lookup component can also work with initially grouped data items. In this case, the data array should contain objects with the key and items fields:

let dataSource = [{
    key: "Group 1", // Group caption 
    items: [ // Items in Group 1
        { /* ... */ },
        { /* ... */ }
    ]
}, {
    key: "Group 2",
    items: [
        { /* ... */ },
        { /* ... */ }
    ]
}];

If data objects are grouped but use other field names, implement the DataSource's map function to create key and items field mappings.

NOTE

Only one-level grouping is supported.

Regardless of the data source structure, enable the grouped property.

Configure the Drop-Down List

The JavaScript Lookup component uses the Popover component as a drop-down list. To customize the Popover, use the dropDownOptions property. It accepts an object with Popover properties. Alternatively, you can set the usePopover property to false to display lookup items in a pop-up window.

DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Lookup - Basics

The Lookup component allows users to search through its drop-down list and select a single item. The drop-down list can be grouped by category.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the Lookup features used.
Backend API
<template> <div> <div class="dx-fieldset"> <div class="dx-fieldset-header">Simple lookup</div> <div class="dx-field"> <DxLookup :items="employeesList" :value="employeesList[0]" :input-attr="{ 'aria-label': 'Simple lookup' }" > <DxDropDownOptions :show-title="false"/> </DxLookup> </div> </div> <div class="dx-fieldset"> <div class="dx-fieldset-header">Grouped lookup</div> <div class="dx-field"> <DxLookup :data-source="dataSource" :grouped="true" :input-attr="{ 'aria-label': 'Grouped lookup' }" display-expr="Subject" > <DxDropDownOptions :hide-on-outside-click="true" :show-title="false" /> </DxLookup> </div> </div> </div> </template> <script setup lang="ts"> import { DxLookup, DxDropDownOptions } from 'devextreme-vue/lookup'; import { DataSource, ArrayStore } from 'devextreme-vue/common/data'; import { employeesList, employeesTasks } from './data.ts'; const dataSource = new DataSource({ store: new ArrayStore({ data: employeesTasks, key: 'ID', }), group: 'Assigned', }); </script>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
export const employeesList = ['John Heart', 'Samantha Bright', 'Arthur Miller', 'Robert Reagan', 'Greta Sims', 'Brett Wade', 'Sandra Johnson', 'Ed Holmes', 'Barb Banks', 'Kevin Carter', 'Cindy Stanwick', 'Sammy Hill', 'Davey Jones', 'Victor Norris', 'Mary Stern', 'Robin Cosworth', 'Kelly Rodriguez', 'James Anderson', 'Antony Remmen', 'Olivia Peyton', 'Taylor Riley', 'Amelia Harper', 'Wally Hobbs', 'Brad Jameson', 'Karen Goodson', 'Marcus Orbison', 'Sandy Bright', 'Morgan Kennedy', 'Violet Bailey', 'Ken Samuelson', 'Nat Maguiree', 'Bart Arnaz', 'Leah Simpson', 'Arnie Schwartz', 'Billy Zimmer', 'Samantha Piper', 'Maggie Boxter', 'Terry Bradley', 'Gabe Jones', 'Lucy Ball', 'Jim Packard', 'Hannah Brookly', 'Harv Mudd', 'Clark Morgan', 'Todd Hoffman', 'Jackie Garmin', 'Lincoln Bartlett', 'Brad Farkus', 'Jenny Hobbs', 'Dallas Lou', 'Stu Pizaro']; export const employeesTasks = [{ ID: 1, Assigned: 'Mr. John Heart', Subject: 'Choose between PPO and HMO Health Plan', }, { ID: 2, Assigned: 'Mr. John Heart', Subject: 'Google AdWords Strategy', }, { ID: 3, Assigned: 'Mr. John Heart', Subject: 'New Brochures', }, { ID: 4, Assigned: 'Mr. John Heart', Subject: 'Update NDA Agreement', }, { ID: 5, Assigned: 'Mr. John Heart', Subject: 'Review Product Recall Report by Engineering Team', }, { ID: 6, Assigned: 'Mrs. Olivia Peyton', Subject: 'Update Personnel Files', }, { ID: 7, Assigned: 'Mrs. Olivia Peyton', Subject: 'Review Health Insurance Options Under the Affordable Care Act', }, { ID: 8, Assigned: 'Mrs. Olivia Peyton', Subject: 'Non-Compete Agreements', }, { ID: 9, Assigned: 'Mrs. Olivia Peyton', Subject: 'Give Final Approval for Refunds', }, { ID: 10, Assigned: 'Mr. Robert Reagan', Subject: 'Deliver R&D Plans for 2013', }, { ID: 11, Assigned: 'Mr. Robert Reagan', Subject: 'Decide on Mobile Devices to Use in the Field', }, { ID: 12, Assigned: 'Mr. Robert Reagan', Subject: 'Try New Touch-Enabled WinForms Apps', }, { ID: 13, Assigned: 'Mr. Robert Reagan', Subject: 'Approval on Converting to New HDMI Specification', }, { ID: 14, Assigned: 'Ms. Greta Sims', Subject: 'Approve Hiring of John Jeffers', }, { ID: 15, Assigned: 'Ms. Greta Sims', Subject: 'Update Employee Files with New NDA', }, { ID: 16, Assigned: 'Ms. Greta Sims', Subject: 'Provide New Health Insurance Docs', }];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
.dx-theme-generic .dx-fieldset, .dx-theme-material .dx-fieldset { width: 40%; float: left; } .dx-field > .dx-lookup { flex: 1; }
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

Bind the Component to Data

To bind the component to data, use one of these properties:

  • items[]
    Accepts a local data array (see the Simple Lookup code below).

  • dataSource
    Accepts a local data array or a DataSource object. This object works with local and remote arrays and allows you to shape data. In this demo, a DataSource instance is configured to group a local array of objects (see the Grouped Lookup code below).

Both properties work with arrays of primitives or objects. If you use objects, specify the following properties:

  • valueExpr
    A data field that contains unique values used to identify items.

  • displayExpr
    A data field whose values should be displayed in the drop-down list.

When a user selects an item, the Lookup component saves the corresponding value from the valueExpr data field in the value property. You can also specify the value property in code to preselect an item as shown in the Simple Lookup use case.

Group Data

You can group data items in the drop-down list.

If the data source contains ungrouped data items, use the DataSource's group property to specify the data field to group by.

The Lookup component can also work with initially grouped data items. In this case, the data array should contain objects with the key and items fields:

let dataSource = [{
    key: "Group 1", // Group caption 
    items: [ // Items in Group 1
        { /* ... */ },
        { /* ... */ }
    ]
}, {
    key: "Group 2",
    items: [
        { /* ... */ },
        { /* ... */ }
    ]
}];

If data objects are grouped but use other field names, implement the DataSource's map function to create key and items field mappings.

Only one-level grouping is supported.

Regardless of the data source structure, enable the grouped property.

Configure the Drop-Down List

The Lookup component uses the Popover component as a drop-down list. To customize the Popover, use the dropDownOptions property. It accepts an object with Popover properties. Alternatively, you can set the usePopover property to false to display lookup items in a pop-up window.

import React from 'react';
import { Lookup, DropDownOptions } from 'devextreme-react/lookup';
import { DataSource, ArrayStore } from 'devextreme-react/common/data';
import { employeesList, employeesTasks } from './data.ts';
const simpleLookupLabel = { 'aria-label': 'Simple lookup' };
const groupedLookupLabel = { 'aria-label': 'Grouped lookup' };
const groupedData = new DataSource({
store: new ArrayStore({
data: employeesTasks,
key: 'ID',
}),
group: 'Assigned',
});
const App = () => (
<div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Simple lookup</div>
<div className="dx-field">
<Lookup
items={employeesList}
defaultValue={employeesList[0]}
inputAttr={simpleLookupLabel}
>
<DropDownOptions showTitle={false} />
</Lookup>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Grouped lookup</div>
<div className="dx-field">
<Lookup
dataSource={groupedData}
grouped={true}
displayExpr="Subject"
inputAttr={groupedLookupLabel}
>
<DropDownOptions
hideOnOutsideClick={true}
showTitle={false}
/>
</Lookup>
</div>
</div>
</div>
);
export default App;
import React from 'react';
import { Lookup, DropDownOptions } from 'devextreme-react/lookup';
import { DataSource, ArrayStore } from 'devextreme-react/common/data';
import { employeesList, employeesTasks } from './data.js';
const simpleLookupLabel = { 'aria-label': 'Simple lookup' };
const groupedLookupLabel = { 'aria-label': 'Grouped lookup' };
const groupedData = new DataSource({
store: new ArrayStore({
data: employeesTasks,
key: 'ID',
}),
group: 'Assigned',
});
const App = () => (
<div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Simple lookup</div>
<div className="dx-field">
<Lookup
items={employeesList}
defaultValue={employeesList[0]}
inputAttr={simpleLookupLabel}
>
<DropDownOptions showTitle={false} />
</Lookup>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Grouped lookup</div>
<div className="dx-field">
<Lookup
dataSource={groupedData}
grouped={true}
displayExpr="Subject"
inputAttr={groupedLookupLabel}
>
<DropDownOptions
hideOnOutsideClick={true}
showTitle={false}
/>
</Lookup>
</div>
</div>
</div>
);
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { Task } from './types.ts';
export const employeesList: string[] = ['John Heart', 'Samantha Bright', 'Arthur Miller', 'Robert Reagan', 'Greta Sims', 'Brett Wade',
'Sandra Johnson', 'Ed Holmes', 'Barb Banks', 'Kevin Carter', 'Cindy Stanwick', 'Sammy Hill', 'Davey Jones', 'Victor Norris',
'Mary Stern', 'Robin Cosworth', 'Kelly Rodriguez', 'James Anderson', 'Antony Remmen', 'Olivia Peyton', 'Taylor Riley',
'Amelia Harper', 'Wally Hobbs', 'Brad Jameson', 'Karen Goodson', 'Marcus Orbison', 'Sandy Bright', 'Morgan Kennedy',
'Violet Bailey', 'Ken Samuelson', 'Nat Maguiree', 'Bart Arnaz', 'Leah Simpson', 'Arnie Schwartz', 'Billy Zimmer', 'Samantha Piper',
'Maggie Boxter', 'Terry Bradley', 'Gabe Jones', 'Lucy Ball', 'Jim Packard', 'Hannah Brookly', 'Harv Mudd', 'Clark Morgan',
'Todd Hoffman', 'Jackie Garmin', 'Lincoln Bartlett', 'Brad Farkus', 'Jenny Hobbs', 'Dallas Lou', 'Stu Pizaro'];
export const employeesTasks: Task[] = [{
ID: 1,
Assigned: 'Mr. John Heart',
Subject: 'Choose between PPO and HMO Health Plan',
}, {
ID: 2,
Assigned: 'Mr. John Heart',
Subject: 'Google AdWords Strategy',
}, {
ID: 3,
Assigned: 'Mr. John Heart',
Subject: 'New Brochures',
}, {
ID: 4,
Assigned: 'Mr. John Heart',
Subject: 'Update NDA Agreement',
}, {
ID: 5,
Assigned: 'Mr. John Heart',
Subject: 'Review Product Recall Report by Engineering Team',
}, {
ID: 6,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Update Personnel Files',
}, {
ID: 7,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
}, {
ID: 8,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Non-Compete Agreements',
}, {
ID: 9,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Give Final Approval for Refunds',
}, {
ID: 10,
Assigned: 'Mr. Robert Reagan',
Subject: 'Deliver R&D Plans for 2013',
}, {
ID: 11,
Assigned: 'Mr. Robert Reagan',
Subject: 'Decide on Mobile Devices to Use in the Field',
}, {
ID: 12,
Assigned: 'Mr. Robert Reagan',
Subject: 'Try New Touch-Enabled WinForms Apps',
}, {
ID: 13,
Assigned: 'Mr. Robert Reagan',
Subject: 'Approval on Converting to New HDMI Specification',
}, {
ID: 14,
Assigned: 'Ms. Greta Sims',
Subject: 'Approve Hiring of John Jeffers',
}, {
ID: 15,
Assigned: 'Ms. Greta Sims',
Subject: 'Update Employee Files with New NDA',
}, {
ID: 16,
Assigned: 'Ms. Greta Sims',
Subject: 'Provide New Health Insurance Docs',
}];
export type Task = {
ID: number;
Assigned: string;
Subject: string;
};
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const employeesList = [
'John Heart',
'Samantha Bright',
'Arthur Miller',
'Robert Reagan',
'Greta Sims',
'Brett Wade',
'Sandra Johnson',
'Ed Holmes',
'Barb Banks',
'Kevin Carter',
'Cindy Stanwick',
'Sammy Hill',
'Davey Jones',
'Victor Norris',
'Mary Stern',
'Robin Cosworth',
'Kelly Rodriguez',
'James Anderson',
'Antony Remmen',
'Olivia Peyton',
'Taylor Riley',
'Amelia Harper',
'Wally Hobbs',
'Brad Jameson',
'Karen Goodson',
'Marcus Orbison',
'Sandy Bright',
'Morgan Kennedy',
'Violet Bailey',
'Ken Samuelson',
'Nat Maguiree',
'Bart Arnaz',
'Leah Simpson',
'Arnie Schwartz',
'Billy Zimmer',
'Samantha Piper',
'Maggie Boxter',
'Terry Bradley',
'Gabe Jones',
'Lucy Ball',
'Jim Packard',
'Hannah Brookly',
'Harv Mudd',
'Clark Morgan',
'Todd Hoffman',
'Jackie Garmin',
'Lincoln Bartlett',
'Brad Farkus',
'Jenny Hobbs',
'Dallas Lou',
'Stu Pizaro',
];
export const employeesTasks = [
{
ID: 1,
Assigned: 'Mr. John Heart',
Subject: 'Choose between PPO and HMO Health Plan',
},
{
ID: 2,
Assigned: 'Mr. John Heart',
Subject: 'Google AdWords Strategy',
},
{
ID: 3,
Assigned: 'Mr. John Heart',
Subject: 'New Brochures',
},
{
ID: 4,
Assigned: 'Mr. John Heart',
Subject: 'Update NDA Agreement',
},
{
ID: 5,
Assigned: 'Mr. John Heart',
Subject: 'Review Product Recall Report by Engineering Team',
},
{
ID: 6,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Update Personnel Files',
},
{
ID: 7,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
},
{
ID: 8,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Non-Compete Agreements',
},
{
ID: 9,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Give Final Approval for Refunds',
},
{
ID: 10,
Assigned: 'Mr. Robert Reagan',
Subject: 'Deliver R&D Plans for 2013',
},
{
ID: 11,
Assigned: 'Mr. Robert Reagan',
Subject: 'Decide on Mobile Devices to Use in the Field',
},
{
ID: 12,
Assigned: 'Mr. Robert Reagan',
Subject: 'Try New Touch-Enabled WinForms Apps',
},
{
ID: 13,
Assigned: 'Mr. Robert Reagan',
Subject: 'Approval on Converting to New HDMI Specification',
},
{
ID: 14,
Assigned: 'Ms. Greta Sims',
Subject: 'Approve Hiring of John Jeffers',
},
{
ID: 15,
Assigned: 'Ms. Greta Sims',
Subject: 'Update Employee Files with New NDA',
},
{
ID: 16,
Assigned: 'Ms. Greta Sims',
Subject: 'Provide New Health Insurance Docs',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-theme-generic .dx-fieldset,
.dx-theme-material .dx-fieldset {
width: 40%;
float: left;
}
.dx-field > .dx-lookup {
flex: 1;
}

<div class="dx-fieldset">
<div class="dx-fieldset-header">Simple lookup</div>
<div class="dx-field">
<dx-lookup
[items]="employees"
[value]="employees[0]"
[inputAttr]="{ 'aria-label': 'Simple lookup' }"
>
<dxo-lookup-drop-down-options
[showTitle]="false"
></dxo-lookup-drop-down-options>
</dx-lookup>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Grouped lookup</div>
<div class="dx-field">
<dx-lookup
displayExpr="Subject"
[dataSource]="dataSource"
[grouped]="true"
[inputAttr]="{ 'aria-label': 'Grouped lookup' }"
>
<dxo-lookup-drop-down-options
[hideOnOutsideClick]="true"
[showTitle]="false"
>
</dxo-lookup-drop-down-options>
</dx-lookup>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxLookupModule } from 'devextreme-angular';
import { DataSource, ArrayStore } from 'devextreme-angular/common/data';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxLookupModule,
],
})
export class AppComponent {
employees: string[];
dataSource: DataSource;
constructor(service: Service) {
this.dataSource = new DataSource({
store: new ArrayStore({
data: service.getTasks(),
key: 'Id',
}),
group: 'Assigned',
});
this.employees = service.getEmployees();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .dx-theme-generic .dx-fieldset,
::ng-deep .dx-theme-material .dx-fieldset {
width: 40%;
float: left;
}
::ng-deep .dx-field > .dx-lookup {
flex: 1;
}
import { Injectable } from '@angular/core';
export class Task {
Id: number;
Assigned: string;
Subject: string;
}
const employeesList: string[] = [
'John Heart', 'Samantha Bright', 'Arthur Miller', 'Robert Reagan', 'Greta Sims', 'Brett Wade',
'Sandra Johnson', 'Ed Holmes', 'Barb Banks', 'Kevin Carter', 'Cindy Stanwick', 'Sammy Hill', 'Davey Jones', 'Victor Norris',
'Mary Stern', 'Robin Cosworth', 'Kelly Rodriguez', 'James Anderson', 'Antony Remmen', 'Olivia Peyton', 'Taylor Riley',
'Amelia Harper', 'Wally Hobbs', 'Brad Jameson', 'Karen Goodson', 'Marcus Orbison', 'Sandy Bright', 'Morgan Kennedy',
'Violet Bailey', 'Ken Samuelson', 'Nat Maguiree', 'Bart Arnaz', 'Leah Simpson', 'Arnie Schwartz', 'Billy Zimmer', 'Samantha Piper',
'Maggie Boxter', 'Terry Bradley', 'Gabe Jones', 'Lucy Ball', 'Jim Packard', 'Hannah Brookly', 'Harv Mudd', 'Clark Morgan',
'Todd Hoffman', 'Jackie Garmin', 'Lincoln Bartlett', 'Brad Farkus', 'Jenny Hobbs', 'Dallas Lou', 'Stu Pizaro',
];
const tasks: Task[] = [{
Id: 1,
Assigned: 'Mr. John Heart',
Subject: 'Choose between PPO and HMO Health Plan',
}, {
Id: 2,
Assigned: 'Mr. John Heart',
Subject: 'Google AdWords Strategy',
}, {
Id: 3,
Assigned: 'Mr. John Heart',
Subject: 'New Brochures',
}, {
Id: 4,
Assigned: 'Mr. John Heart',
Subject: 'Update NDA Agreement',
}, {
Id: 5,
Assigned: 'Mr. John Heart',
Subject: 'Review Product Recall Report by Engineering Team',
}, {
Id: 6,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Update Personnel Files',
}, {
Id: 7,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
}, {
Id: 8,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Non-Compete Agreements',
}, {
Id: 9,
Assigned: 'Mrs. Olivia Peyton',
Subject: 'Give Final Approval for Refunds',
}, {
Id: 10,
Assigned: 'Mr. Robert Reagan',
Subject: 'Deliver R&D Plans for 2013',
}, {
Id: 11,
Assigned: 'Mr. Robert Reagan',
Subject: 'Decide on Mobile Devices to Use in the Field',
}, {
Id: 12,
Assigned: 'Mr. Robert Reagan',
Subject: 'Try New Touch-Enabled WinForms Apps',
}, {
Id: 13,
Assigned: 'Mr. Robert Reagan',
Subject: 'Approval on Converting to New HDMI Specification',
}, {
Id: 14,
Assigned: 'Ms. Greta Sims',
Subject: 'Approve Hiring of John Jeffers',
}, {
Id: 15,
Assigned: 'Ms. Greta Sims',
Subject: 'Update Employee Files with New NDA',
}, {
Id: 16,
Assigned: 'Ms. Greta Sims',
Subject: 'Provide New Health Insurance Docs',
}];
@Injectable()
export class Service {
getEmployees(): string[] {
return employeesList;
}
getTasks(): Task[] {
return tasks;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>